#! /usr/bin/env node
'use strict';

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _express = require('../express');

var _options = require('./options');

var _options2 = _interopRequireDefault(_options);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var options = new _options2.default();

module.paths.push(process.cwd(), _path2.default.join(process.cwd(), 'node_modules'));

options.requireFiles().map(function (file) {
  return require(file);
});

console.log('Loading app from ' + options.appPath());
var app = require(options.appPath()).default;

console.log('DEV=' + options.dev());

(0, _express.createNextServer)({ app: app, dev: options.dev() }).then(function (server) {
  console.log('Listening on port ' + options.port());
  server.listen(options.port());
});