'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

exports.default = asExpressMiddleware;

var _express = require('express');

var _express2 = _interopRequireDefault(_express);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function wrapHandler(handler) {
  return function (_ref) {
    var req = _ref.req,
        res = _ref.res,
        route = _ref.route;

    var ctx = { req: req, res: res, route: route };

    if (route.isPage()) {
      ctx.params = (0, _extends3.default)({}, req.query, req.params);
    } else {
      ctx.params = (0, _extends3.default)({}, req.query, req.params, req.body);
    }

    return handler(ctx);
  };
}

function asExpressMiddleware(app, handler) {
  var router = _express2.default.Router();

  app.routes().forEach(function (route) {
    console.log('Serving', route.method, route.path, 'with', route.action);
    var method = route.method.toLowerCase();
    router[method](route.path, function (req, res) {
      return wrapHandler(handler)({ req: req, res: res, route: route });
    });
  });

  return router;
}