'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

exports.createExpressServer = createExpressServer;

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _express = require('express');

var _express2 = _interopRequireDefault(_express);

var _next = require('next');

var _next2 = _interopRequireDefault(_next);

var _bodyParser = require('body-parser');

var _bodyParser2 = _interopRequireDefault(_bodyParser);

var _asExpressMiddleware = require('./asExpressMiddleware');

var _asExpressMiddleware2 = _interopRequireDefault(_asExpressMiddleware);

var _nextHandler = require('./nextHandler');

var _nextHandler2 = _interopRequireDefault(_nextHandler);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createExpressServer(app, nextApp) {
  var server = (0, _express2.default)();

  // Handle POST data
  server.use(_bodyParser2.default.urlencoded({ extended: true }));

  // Hook up upcoming + express + next
  server.use((0, _asExpressMiddleware2.default)(app, (0, _nextHandler2.default)(nextApp)));

  // Handle 404s and other non-upcoming pages
  server.get('*', function (req, res) {
    return nextApp.getRequestHandler()(req, res);
  });

  return server;
}

exports.default = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(_ref2) {
    var app = _ref2.app,
        dev = _ref2.dev;
    var nextApp;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            nextApp = (0, _next2.default)({ dir: '.', dev: dev });
            _context.next = 3;
            return nextApp.prepare();

          case 3:
            return _context.abrupt('return', createExpressServer(app, nextApp));

          case 4:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  function createNextServer(_x) {
    return _ref.apply(this, arguments);
  }

  return createNextServer;
}();