'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function buildInputProps(props, context) {
  var name = props.name;


  if (!name) {
    throw 'Please give this input a name';
  }

  return (0, _extends3.default)({}, props, {
    onChange: buildOnChange(props, context),
    value: buildValue(props, context),
    checked: buildChecked(props, context)
  });
}

function buildOnChange(props, context) {
  if (props.onChange) return props.onChange;else if (!context.onChange) return function () {
    return null;
  };

  return function (_ref) {
    var target = _ref.target;

    context.onChange(props.name, target.value, {
      type: props.type,
      checked: target.checked
    });
  };
}

function buildValue(props, context) {
  if (props.value) {
    return props.value;
  } else if (context.value) {
    return context.value(props.name) || '';
  }
}

function buildChecked(props, context) {
  if (props.type === 'radio' && context.value) {
    return context.value(props.name) === props.value;
  }
}

var Input = function Input(props, context) {
  return _react2.default.createElement('input', buildInputProps(props, context));
};

Input.contextTypes = {
  onChange: _propTypes2.default.func,
  value: _propTypes2.default.func
};

exports.default = Input;