'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function buildSelectProps(props, context) {
  var name = props.name;


  if (!name) {
    throw 'Please give this select a name';
  }

  return (0, _extends3.default)({}, props, {
    onChange: buildOnChange(props, context),
    value: buildValue(props, context)
  });
}

function buildOnChange(props, context) {
  if (props.onChange) return props.onChange;else if (!context.onChange) return function () {
    return null;
  };

  return function (_ref) {
    var target = _ref.target;

    context.onChange(props.name, valuesFromTarget(props, target), {
      multiple: props.multiple
    });
  };
}

function valuesFromTarget(props, target) {
  if (props.multiple) {
    var values = [];

    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = (0, _getIterator3.default)(target.selectedOptions), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var option = _step.value;

        values.push(option.value);
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return) {
          _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }

    return values;
  } else {
    return target.value;
  }
}

function buildValue(props, context) {
  if (props.value) {
    return props.value;
  } else if (context.value) {
    var value = context.value(props.name);

    if (value) {
      return value;
    } else if (props.multiple) {
      return [];
    } else {
      return '';
    }
  }
}

var Select = function Select(props, context) {
  return _react2.default.createElement(
    'select',
    buildSelectProps(props, context),
    props.children
  );
};

Select.contextTypes = {
  onChange: _propTypes2.default.func,
  value: _propTypes2.default.func
};

exports.default = Select;