'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.route = undefined;

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _pathToRegexp = require('path-to-regexp');

var _pathToRegexp2 = _interopRequireDefault(_pathToRegexp);

var _routes = require('./routes');

var route = _interopRequireWildcard(_routes);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.route = route;

var Republic = function () {
  function Republic() {
    (0, _classCallCheck3.default)(this, Republic);

    for (var _len = arguments.length, routes = Array(_len), _key = 0; _key < _len; _key++) {
      routes[_key] = arguments[_key];
    }

    this._routes = routes;
  }

  (0, _createClass3.default)(Republic, [{
    key: 'routes',
    value: function routes() {
      return this._routes;
    }
  }, {
    key: 'route',
    value: function route(action) {
      return routesByAction(this.routes())[action];
    }
  }, {
    key: 'routeHandlersByModuleAndName',
    value: function routeHandlersByModuleAndName() {
      return _routeHandlersByModuleAndName(this.routes());
    }
  }, {
    key: 'routeHandler',
    value: function routeHandler(action) {
      return this.route(action).handler;
    }
  }, {
    key: 'url',
    value: function url(action, params) {
      var route = this.route(action);

      if (route) {
        return _pathToRegexp2.default.compile(route.path)(params);
      }
    }
  }]);
  return Republic;
}();

exports.default = Republic;


function routesByAction(routes) {
  var routesByAction = {};

  routes.forEach(function (route) {
    routesByAction[route.action] = route;
  });

  return routesByAction;
}

function _routeHandlersByModuleAndName(routes) {
  var routesByModuleAndName = {};

  routes.forEach(function (route) {
    var _route$action$split = route.action.split('#'),
        _route$action$split2 = (0, _slicedToArray3.default)(_route$action$split, 2),
        mod = _route$action$split2[0],
        name = _route$action$split2[1];

    routesByModuleAndName[mod] = routesByModuleAndName[mod] || {};
    routesByModuleAndName[mod][name] = route.handler;
  });

  return routesByModuleAndName;
}