'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

exports.page = page;
exports.GET = GET;
exports.POST = POST;
exports.DELETE = DELETE;

var _lodash = require('lodash.flowright');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createRoute(method, path, action) {
  for (var _len = arguments.length, callbacks = Array(_len > 3 ? _len - 3 : 0), _key = 3; _key < _len; _key++) {
    callbacks[_key - 3] = arguments[_key];
  }

  var handler = function () {
    var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(params) {
      var ctx = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var middleware, fn;
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (!(callbacks.length > 0)) {
                _context.next = 6;
                break;
              }

              middleware = [].concat((0, _toConsumableArray3.default)(callbacks));
              fn = middleware.pop();
              _context.next = 5;
              return _lodash2.default.apply(undefined, (0, _toConsumableArray3.default)(middleware))(fn)((0, _extends3.default)({ params: params }, ctx));

            case 5:
              return _context.abrupt('return', _context.sent);

            case 6:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    return function handler(_x) {
      return _ref.apply(this, arguments);
    };
  }();

  var _action$split = action.split('#'),
      _action$split2 = (0, _slicedToArray3.default)(_action$split, 2),
      module = _action$split2[0],
      name = _action$split2[1];

  callbacks = callbacks.length > 0 ? [].concat.apply([], callbacks) : [];

  handler.method = method;
  handler.path = path;

  return {
    method: method,
    path: path,
    action: action,
    module: module,
    name: name,
    isPage: function isPage() {
      return false;
    },

    handler: handler
  };
}

function page(path, action) {
  for (var _len2 = arguments.length, callbacks = Array(_len2 > 2 ? _len2 - 2 : 0), _key2 = 2; _key2 < _len2; _key2++) {
    callbacks[_key2 - 2] = arguments[_key2];
  }

  return (0, _extends3.default)({}, createRoute.apply(undefined, ['GET', path, action].concat(callbacks)), {
    isPage: function isPage() {
      return true;
    }
  });
}

function GET(path, action) {
  for (var _len3 = arguments.length, callbacks = Array(_len3 > 2 ? _len3 - 2 : 0), _key3 = 2; _key3 < _len3; _key3++) {
    callbacks[_key3 - 2] = arguments[_key3];
  }

  return createRoute.apply(undefined, ['GET', path, action].concat(callbacks));
}

function POST(path, action) {
  for (var _len4 = arguments.length, callbacks = Array(_len4 > 2 ? _len4 - 2 : 0), _key4 = 2; _key4 < _len4; _key4++) {
    callbacks[_key4 - 2] = arguments[_key4];
  }

  return createRoute.apply(undefined, ['POST', path, action].concat(callbacks));
}

function DELETE(path, action) {
  for (var _len5 = arguments.length, callbacks = Array(_len5 > 2 ? _len5 - 2 : 0), _key5 = 2; _key5 < _len5; _key5++) {
    callbacks[_key5 - 2] = arguments[_key5];
  }

  return createRoute.apply(undefined, ['DELETE', path, action].concat(callbacks));
}