#! /usr/bin/env node

import path from 'path'
import { createNextServer } from '../express'
import Options from './options'

const options = new Options

module.paths.push(process.cwd(), path.join(process.cwd(), 'node_modules'))

options.requireFiles().map(file => require(file))

console.log(`Loading app from ${options.appPath()}`)
const app = require(options.appPath()).default

console.log(`DEV=${options.dev()}`)

createNextServer({ app, dev: options.dev() }).then((server) => {
  console.log(`Listening on port ${options.port()}`)
  server.listen(options.port())
})
